##Written by Sam Yeaman
##Used to test whether genome-wide tandem duplicates have similar patterns of expression, and compare these to the BIA genes 

options(stringsAsFactors=F)
setwd("~/Dropbox/desktop/for_sukyi")


all_rnaseq <- read.table ("~/Dropbox/desktop/for_sukyi/gene_tpm_all_samples_filt.tsv",T,sep = "\t")
gff <- read.table ("~/Dropbox/desktop/for_sukyi/poppy_V3.2_fix_inversion_top_level.mrna.filt.MIA.final.109.strandchecked.gff3.txt",sep = "\t")

gff2 <- gff[grep("coverage",gff[,9]),]
gff3 <- gff[grep("coverage",gff[,9],invert = T),]

int1 <- sapply(strsplit (gff2[,9],split = ";"),"[[",5) ##filter by ID
int2 <- sapply(strsplit (int1,split = "="),"[[",2)
gff_new2 <- gff2[which(as.numeric (int2) > 90),] 
int1 <- sapply(strsplit (gff_new2[,9],split = ";"),"[[",4) #filter by coverage
int2 <- sapply(strsplit (int1,split = "="),"[[",2)
gff_new3 <- gff_new2[which(as.numeric (int2) > 90),]

gff <- rbind (gff3,gff_new3)

int1 <- sapply (strsplit (gff[,9],split = "Parent="),"[[",2)
int2 <- sapply (strsplit (int1,split = ";",1),"[[",1)

gff2 <- cbind (int2,gff[,1],gff[,4],gff[,5])
write.table (gff2,"temp454.txt")
gff2 <- read.table ("temp454.txt")

all_rnaseq2 <- merge (all_rnaseq, gff2,by.x = "Gene_ID", by.y = "int2")

temp1 <- all_rnaseq2[,2:14] > 0.1
all_rnaseq3 <- all_rnaseq2[rowSums (temp1) >= 5,]


bb <- sapply(strsplit (as.character (all_rnaseq3$Gene_ID),".path",fixed = T),"[[",1)

tab_bb <- table (bb)

tab_bb2 <- tab_bb [tab_bb > 2]


all_rnaseq4 <- all_rnaseq3[bb %in% names (tab_bb2),]


bb_new <- sapply(strsplit (as.character (all_rnaseq4$Gene_ID),".path",fixed = T),"[[",1)

all_rnaseq4$gene <- bb_new

nam_unique <- unique (bb_new)

count <- 1
results <- array (NA, c(50000,5))

for (i in 1:length (nam_unique)){
 
  sub1 <- all_rnaseq4[all_rnaseq4$gene == nam_unique[i],]
   
  
  for (j in 1:nrow(sub1)){
  for (k in 1:nrow(sub1)){
    
    if (j < k){
      
      results[count,1] <- sub1[j,]$X
      results[count,2] <- sub1[k,]$X
      results[count,3] <- sub1[j,]$X.1
      results[count,4] <- sub1[k,]$X.1
      dd <- rbind (log10(sub1[j,2:14]+1),log10(sub1[k,2:14]+1))
      results[count,5] <- cor (as.numeric (dd[1,]),as.numeric (dd[2,]),method="spearman")
      count <- count + 1
    }
  }
  }
  
  
}
results <- results [1:(count-1),]

write.table (results,"temp1235.txt")
results <- read.table ("temp1235.txt")

results_tandem <- results[results[,1] == results[,2] & (abs(results[,3] - results[,4]) < 500000),]
results_nontandem <- results[!(results[,1] == results[,2] & (abs(results[,3] - results[,4]) < 500000)),]


mean (results_tandem[,5])
mean (results_nontandem[,5])


write.table (results, "results_all_tandem_non_tandem_duplicates.txt")

