##Written by Sam Yeaman
##used to plot co-expression statistics for Figure 3c, Figure S12, 


options(stringsAsFactors=F)
setwd("~/Dropbox/desktop/for_sukyi")



tandem <- read.table ("~/Dropbox/desktop/for_sukyi/pathway_genes_hic_inversion_clustered_edited_tandem_reviewed_by_Qiushi_SY.txt",T,sep = "\t")
tandem <- tandem[,1:13]
non_tandem <- tandem[tandem$tandem == "solo",]
non_tandem$gene_name <- paste (sapply(strsplit(non_tandem$path,split = ".", fixed = T),"[[",1),".",sapply(strsplit(non_tandem$path,split = "loc", fixed = T),"[[",2),sep = "")





exp_all <- read.table ("~/Dropbox/desktop/for_sukyi/gene_tpm_all_samples_filt.path.N.clust.sam.txt",T)
exp_all <- exp_all[,-c(15:18)]

pathway <- read.table ("~/Dropbox/desktop/for_sukyi/pathway_genes_hic_inversion_clustered.txt", header = T, sep = "\t")
pathway$position <- paste (pathway$Chromosome,pathway$Start, sep = "---")

exp_all <- merge (exp_all,pathway,by.x = "position",by.y = "position")

to_cluster <- "clust0.5"
this_clust <- which (colnames(exp_all) == to_cluster)



ind_cut1 <- 3
ind_cut2 <- 15





all_rnaseq <- read.table ("~/Dropbox/desktop/for_sukyi/gene_tpm_all_samples_filt.tsv",T,sep = "\t")
gff <- read.table ("~/Dropbox/desktop/for_sukyi/poppy_V3.2_fix_inversion_top_level.mrna.filt.MIA.final.109.strandchecked.gff3.txt",sep = "\t")

int1 <- sapply (strsplit (gff[,9],split = "Parent="),"[[",2)
int2 <- sapply (strsplit (int1,split = ";",1),"[[",1)

gff2 <- cbind (int2,gff[,1],gff[,4],gff[,5])
write.table (gff2,"temp454.txt")
gff2 <- read.table ("temp454.txt")

all_rnaseq2 <- merge (all_rnaseq, gff2,by.x = "Gene_ID", by.y = "int2")

#get rid of any genes that are present in the BIA genes:

all_rnaseq3 <- NULL

test_remove <- NULL

for (j in 1:nrow (exp_all)){

	sub1 <- all_rnaseq2[all_rnaseq2$X == exp_all$Chromosome[j],]

	rowsum_check <- sum (as.numeric (exp_all[j,ind_cut1:ind_cut2]))
	
	rowsums1 <- rowSums((sub1[,2:14]))

	rowsum_check2 <- which (rowsums1 > (rowsum_check * 0.9) & rowsums1 < (rowsum_check * 1.1))

	sub2 <- sub1[rowsum_check2,]

	for (k in 1:nrow(sub2)){
		
		check_row <- sum (as.numeric (sub2[k,2:14]) != 0)
		
		if (check_row > 2){
			test1 <- cor (log10(as.numeric (sub2[k,2:14])+1),log10(as.numeric (exp_all[j,ind_cut1:ind_cut2])+1))
			if (test1 > 0.999){
				test_remove <- c (test_remove,sub2$Gene_ID[k])
			}
		}
	}
	
}

all_rnaseq3 <- all_rnaseq2[!(all_rnaseq2$Gene_ID %in% test_remove),]

ind1 <- rowSums (all_rnaseq3[,2:14] > 0.1) #how many have at least 0.1 TPM
all_rnaseq4 <- all_rnaseq3[ind1 >= 5,] ##keep only the libraries that have >0.1 TPM for at least 5 libraries



res_cor <- array (NA, c (nrow(exp_all)^2,10))

##TRIM dual-pathway genes and rename some pathways
exp_all$pathway_new.y <- gsub ("papaverine_derivatives","papaverine",exp_all$pathway_new.y)
exp_all$pathway_new.y <- gsub ("reticuline_derivatives","reticuline",exp_all$pathway_new.y)
exp_all <- exp_all[!(exp_all$pathway_new.y %in% c("noscapine_sanguinarine","papaverine_sanguinarine")),]




##to exclude tandem-duplicates:
#exp_all <- exp_all[exp_all$Gene_ID %in% non_tandem$gene_name,]

count_cor <- 1


pathway_ind <- which (colnames(exp_all) == "pathway_new.y")
low_ind <- which (colnames(exp_all) == "Low")
chrom_ind <- which (colnames(exp_all) == "scaffold_name")
ind_cut1 <- 3
ind_cut2 <- 15

for (i in 1:(nrow(exp_all)-1)){
for (j in (i+1):nrow(exp_all)){
	
	if (i != j){

		sub1_check <- rbind (as.numeric (exp_all[i,ind_cut1:ind_cut2]),as.numeric (exp_all[j,ind_cut1:ind_cut2]))
		sub1_check2 <- colSums(sub1_check != 0)
	
		if (sum (sub1_check2 == 2) >= 5){
			res_cor[count_cor,9] <- cor ((log10(sub1_check[1,]+1)),log10(sub1_check[2,]+1),method="spearman")
		}
	}

	res_cor[count_cor,1] <- exp_all[i,2] #gene_ID1
	res_cor[count_cor,2] <- exp_all[j,2] #gene_ID2
	res_cor[count_cor,3] <- exp_all[i,this_clust] #cluster1
	res_cor[count_cor,4] <- exp_all[j,this_clust] #cluster2
	res_cor[count_cor,5] <- sapply (strsplit (exp_all[i,2],split = ".",fixed = T),"[[",1)
	res_cor[count_cor,6] <- sapply (strsplit (exp_all[j,2],split = ".",fixed = T),"[[",1)
	res_cor[count_cor,7] <- exp_all[i,pathway_ind]
	res_cor[count_cor,8] <- exp_all[j,pathway_ind]
	if (exp_all[i,chrom_ind] == exp_all[j,chrom_ind]){
		res_cor[count_cor,10] <- abs(exp_all[i,low_ind] - exp_all[j,low_ind])
	}
	count_cor <- count_cor + 1


}
	
}

colnames (res_cor) <- c("name1","name2","cluster1","cluster2","gene1","gene2","path1","path2","cor","distance")


write.table (res_cor,"tmep676.txt")
res_cor <- read.table ("tmep676.txt")

path_table <- cbind (exp_all$Gene_ID,exp_all$pathway_new.y)

colnames (path_table) <- c ("Gene_ID","pathway_new")


write.table (path_table,"tmep677.txt")
path_table <- read.table ("tmep677.txt")


int1 <- res_cor[which(res_cor$gene1 != res_cor$gene2),] ##trim tandem duplicates for same cluster
same_path_same_clust <- int1[which(int1$path1 == int1$path2 & int1$cluster1 == int1$cluster2),]
diff_path_same_clust <- int1[which(int1$path1 != int1$path2 & int1$cluster1 == int1$cluster2),]


same_path_diff_clust <- res_cor[which(res_cor$path1 == res_cor$path2 & res_cor$cluster1 != res_cor$cluster2),]
diff_path_diff_clust <- res_cor[which(res_cor$path1 != res_cor$path2 & res_cor$cluster1 != res_cor$cluster2),]

same_path_same_clust_tandem <- res_cor[which(res_cor$gene1 == res_cor$gene2 & res_cor$cluster1 == res_cor$cluster2),] 


same_path_same_clust_noUn <- same_path_same_clust[same_path_same_clust$path1 != "unknown",]
same_path_diff_clust_noUn <- same_path_diff_clust[same_path_diff_clust$path1 != "unknown",]


mean (same_path_same_clust$cor^2,na.rm = T)
mean (diff_path_same_clust$cor^2,na.rm = T)
mean (same_path_diff_clust$cor^2,na.rm = T)
mean (diff_path_diff_clust$cor^2,na.rm = T)

mean (same_path_same_clust_noUn$cor^2,na.rm = T)
mean (same_path_diff_clust_noUn$cor^2,na.rm = T)






b1 <- tapply (same_path_same_clust$cor^2, same_path_same_clust$path1,mean)
b2 <- tapply (same_path_diff_clust$cor^2, same_path_diff_clust$path1,mean)

out1 <- rbind (cbind(same_path_same_clust$path1,array("same",nrow(same_path_same_clust)),same_path_same_clust$cor),cbind(same_path_diff_clust$path1,array("diff",nrow(same_path_diff_clust)),same_path_diff_clust$cor))

out1 <- out1[out1[,1] != "unknown",]

write.table(out1,"temp454.txt")
out1 <- read.table ("temp454.txt")
out1[,2] <- as.factor(out1[,2])
out1[,1] <- as.factor(out1[,1])

lm1 <- aov (out1 [,3] ~ out1[,2] * out1[,1])

t.test (same_path_same_clust[same_path_same_clust [,7] == "thebaine",]$cor^2,same_path_diff_clust[same_path_diff_clust [,7] == "thebaine",]$cor^2)
t.test (same_path_same_clust[same_path_same_clust [,7] == "papaverine",]$cor^2,same_path_diff_clust[same_path_diff_clust [,7] == "papaverine",]$cor^2)
t.test (same_path_same_clust[same_path_same_clust [,7] == "sanguinarine",]$cor^2,same_path_diff_clust[same_path_diff_clust [,7] == "sanguinarine",]$cor^2)
t.test (same_path_same_clust[same_path_same_clust [,7] == "reticuline",]$cor^2,same_path_diff_clust[same_path_diff_clust [,7] == "reticuline",]$cor^2)
t.test (same_path_same_clust[same_path_same_clust [,7] == "unknown",]$cor^2,same_path_diff_clust[same_path_diff_clust [,7] == "unknown",]$cor^2)




thebaine_scaf7 <- c("SalAT.1","SalR.1","THS-1.1")
thebaine_scaf11 <- c("SalAT.2","SalR.2","THS-2.1")

nos_the7 <- res_cor[(res_cor$name1 %in% thebaine_scaf7 & res_cor$path1 == "noscapine") | (res_cor$name2 %in% thebaine_scaf7 & res_cor$path1 == "noscapine") | (res_cor$name1 %in% thebaine_scaf7 & res_cor$path2 == "noscapine") | (res_cor$name2 %in% thebaine_scaf7 & res_cor$path2 == "noscapine"),]
nos_the11 <- res_cor[(res_cor$name1 %in% thebaine_scaf11 & res_cor$path1 == "noscapine") | (res_cor$name2 %in% thebaine_scaf11 & res_cor$path1 == "noscapine") | (res_cor$name1 %in% thebaine_scaf11 & res_cor$path2 == "noscapine") | (res_cor$name2 %in% thebaine_scaf11 & res_cor$path2 == "noscapine"),]

the7_the11 <- res_cor[(res_cor$name1 %in% thebaine_scaf11 & res_cor$path1 == "noscapine"),]

mean (nos_the7$cor^2)
mean (nos_the11$cor^2)


##plot: same pqthway
plot_same_path_same_clust <- rbind (same_path_same_clust, c(NA,NA,NA,NA,NA,NA,"morphine","morphine",-999))
plot_same_path_same_clust <- rbind (plot_same_path_same_clust, c(NA,NA,NA,NA,NA,NA,"dopamine_4HPAA","dopamine_4HPAA",-999))
plot_same_path_diff_clust <- rbind (same_path_diff_clust, c(NA,NA,NA,NA,NA,NA,"noscapine","noscapine",-999))
plot_same_path_same_clust_tandem <- rbind (same_path_same_clust_tandem, c(NA,NA,NA,NA,NA,NA,"noscapine","noscapine",-999))
plot_same_path_same_clust_tandem <- rbind (plot_same_path_same_clust_tandem, c(NA,NA,NA,NA,NA,NA,"reticuline","reticuline",-999))
plot_same_path_same_clust_tandem <- rbind (plot_same_path_same_clust_tandem, c(NA,NA,NA,NA,NA,NA,"sanguinarine","sanguinarine",-999))

plot_same_path_diff_clust <- plot_same_path_diff_clust[plot_same_path_diff_clust$path1 %in% plot_same_path_same_clust$path1,]
plot_same_path_same_clust <- plot_same_path_same_clust[plot_same_path_same_clust$path1 %in% plot_same_path_diff_clust$path1,]
plot_same_path_same_clust_tandem <- plot_same_path_same_clust_tandem[plot_same_path_same_clust_tandem$path1 %in% plot_same_path_diff_clust$path1,]

write.table (plot_same_path_same_clust,"temp7787.txt")
plot_same_path_same_clust <- read.table ("temp7787.txt")

write.table (plot_same_path_diff_clust,"temp7787.txt")
plot_same_path_diff_clust <- read.table ("temp7787.txt")

write.table (plot_same_path_same_clust_tandem,"temp7787.txt")
plot_same_path_same_clust_tandem <- read.table ("temp7787.txt")






####



exp_all <- read.table ("~/Dropbox/desktop/for_sukyi/gene_tpm_all_samples_filt.path.N.clust.sam.txt",T)
exp_all <- exp_all[,-c(15:18)]

pathway <- read.table ("~/Dropbox/desktop/for_sukyi/pathway_genes_hic_inversion_clustered.txt", header = T, sep = "\t")
pathway$position <- paste (pathway$Chromosome,pathway$Start, sep = "---")

exp_all <- merge (exp_all,pathway,by.x = "position",by.y = "position")


this_clust <- which (colnames(exp_all) == to_cluster)
clusters <- exp_all[exp_all[,this_clust] > 0,]
clusters <- clusters[order(clusters[,this_clust]),]
the_clust <- unique (clusters[,this_clust])


all_rnaseq4 <- read.table ("all_rnaseq_tpm0.1_num5.txt",T,sep = "\t")

cor_nonbia_all <- NULL
cor_nonbia_all_clust <- NULL

for (i in 1:length (the_clust)){
	

	sub1 <- clusters[clusters[,this_clust] == the_clust[i],]


	sub_all_rnaseq <- all_rnaseq4[all_rnaseq4$X == sub1$Chromosome[1],]
	sub_all_rnaseq2 <- sub_all_rnaseq [sub_all_rnaseq$X.1 > min(sub1$Low) & sub_all_rnaseq$X.1 < max(sub1$High),]

	cor_nonbia <- NULL
	cor_bia_nonbia <- NULL

		
	#within clusters correlations among non-BIA genes:
	if (nrow (sub_all_rnaseq2) >= 2){
		
	for (j in 1:nrow (sub_all_rnaseq2)){
	for (k in 1:nrow (sub_all_rnaseq2)){
		
		if (j != k){

			sub1_check <- rbind (as.numeric (sub_all_rnaseq2[j,2:14]),as.numeric (sub_all_rnaseq2[k,2:14]))
			sub1_check2 <- colSums(sub1_check != 0)
			
			if (sum (sub1_check2 == 2) >= 5){
											
				cor_nonbia_all <- c(cor_nonbia_all,cor ((log10(sub1_check[1,]+1)),log10(sub1_check[2,]+1),method="spearman"))
				cor_nonbia_all_clust <- c(cor_nonbia_all_clust,the_clust[i])
								
			}
			
		}
		
	}
	}	
	
		
	}
	
		
}





####
##FIGURE 3C
#quartz()
par (mfcol = c (1,1))
par (mar = c (10,5,5,1))
stripchart (plot_same_path_diff_clust$cor^2 ~ plot_same_path_diff_clust$path1, vertical = T, method = "jitter",pch = 1,ylim = c (0,1.25),col = "grey50",ylab = expression (paste("Correlation in expression among genes (",rho^2,")")), xaxt = "n",yaxt = "n",cex.lab = 1.5)
par (new = T)
stripchart (plot_same_path_same_clust$cor^2 ~ plot_same_path_same_clust$path1, vertical = T, method = "jitter",pch = 24,ylim = c (0,1.25),ylab = "",xaxt = "n",yaxt = "n")
par (new = T)
stripchart (plot_same_path_same_clust_tandem$cor^2 ~ plot_same_path_same_clust_tandem$path1, vertical = T, method = "jitter",pch = 24,ylim = c (0,1.25),ylab = "",xaxt = "n",yaxt = "n", col = rgb(1,0,0,alpha = 1))
par (las = 3)
lab1 <- sort (unique(plot_same_path_diff_clust$path1))
lab1[1] <- "dopamine"
axis (1, at = 1:8,labels = lab1,cex.axis = 1.5)
par (las = 1)
axis (2, at = c(0,0.2,0.4,0.6,0.8,1),labels = c(0,0.2,0.4,0.6,0.8,1.0))

legend ("topright",c("same pathway, same cluster","same pathway, different cluster","putative tandem duplication"),pch = c (24,1,24), col = c("black","grey50","red"),cex = 1.2, bty = "n")


par (mar = c (10,4,5,2))

nbins1 <- 30
plot (density (diff_path_same_clust$cor^2,na.rm = T, from = 0, to = 1, n = nbins1), type = "l",ylim = c (0,3), lwd = 2,col = "darkorange",main = "",xlab = expression (paste("Correlation in expression among genes (",rho^2,")")))
points (density (same_path_same_clust$cor^2,na.rm = T, from = 0, to = 1, n = nbins1), col = "black", type = "l", lwd = 2)
points (density (same_path_diff_clust$cor^2,na.rm = T, from = 0, to = 1, n = nbins1), col = "grey50", type = "l", lwd = 2)
points (density (cor_nonbia_all ^2,na.rm = T, from = 0, to = 1, n = nbins1), col = "purple", type = "l", lwd = 2)

legend ("topright",c("same pathway, same cluster","same pathway, different cluster","different pathway, same cluster","non-BIA, same cluster"),lty = c (1,1,1,1), col = c("black","grey50","darkorange","purple"),cex = 0.8)





quartz()
##plot: same cluster
plot_diff_path_same_clust <- diff_path_same_clust[diff_path_same_clust$cluster1 %in% same_path_same_clust$cluster1,]
plot_same_path_same_clust <- same_path_same_clust[same_path_same_clust$cluster1 %in% diff_path_same_clust$cluster1,]

stripchart (plot_diff_path_same_clust$cor^2 ~ plot_diff_path_same_clust$cluster1, vertical = T, method = "jitter",pch = 1,ylim = c (0,1),col = "grey50",ylab = "Pairwise correlation among gene expression (rho)")
par (new = T)
stripchart (plot_same_path_same_clust$cor^2 ~ plot_same_path_same_clust$cluster1, vertical = T, method = "jitter",pch = 19,ylim = c (0,1),ylab = "",xaxt = "n",yaxt = "n")




###permutation test:


###

num_rand <- 1000

same_path_same_clust_vs_same_path_diff_clust <- array (NA,num_rand)

permute_same_path_same_clust <- NA

for (pp in 1:num_rand){
	
	new_res_cor <- res_cor
	new_path <- path_table
	new_path[,2] <- sample (path_table[,2],nrow(path_table),replace = F)
	
	for (qq in 1:nrow (new_path)){
	
		ind1 <- which (res_cor[,1] == new_path[qq,1])
		new_res_cor[ind1,7] <- new_path[qq,2]

		ind1 <- which (res_cor[,2] == new_path[qq,1])
		new_res_cor[ind1,8] <- new_path[qq,2]
		
	}
	
	
	int1 <- new_res_cor[which(new_res_cor$gene1 != new_res_cor$gene2),] ##trim tandem duplicates for same cluster
	temp_same_path_same_clust <- int1[(int1$path1 == int1$path2 & int1$cluster1 == int1$cluster2),]
	temp_same_path_diff_clust <- int1[(int1$path1 != int1$path2 & int1$cluster1 == int1$cluster2),]

	test1 <- (wilcox.test(temp_same_path_same_clust$cor, temp_same_path_diff_clust$cor))$statistic
#	size1 [pp] <- nrow (temp_same_path_diff_clust)

	num1 <- sum (is.na (temp_same_path_diff_clust$cor) == F) 
	num2 <- sum (is.na (temp_same_path_same_clust$cor) == F) 

	zscore1 <- (2 * test1 - num1 * num2) / sqrt ( num1 * num2 * (num1 + num2 + 1)/ 3 )	
		
		
	same_path_same_clust_vs_same_path_diff_clust[pp] <- zscore1
	
}



test2 <- (wilcox.test ((same_path_diff_clust$cor^2),(same_path_same_clust$cor^2)))$statistic
test3 <- (wilcox.test ((same_path_same_clust$cor^2),(same_path_diff_clust$cor^2)))$statistic


num1 <- sum (is.na (same_path_diff_clust$cor) == F) 
num2 <- sum (is.na (same_path_same_clust$cor) == F) 



zscore2 <- (2 * test2 - num1 * num2) / sqrt ( num1 * num2 * (num1 + num2 + 1)/ 3 )
zscore3 <- (2 * test3 - num1 * num2) / sqrt ( num1 * num2 * (num1 + num2 + 1)/ 3 )


sum (same_path_same_clust_vs_same_path_diff_clust > zscore2) / num_rand
sum (same_path_same_clust_vs_same_path_diff_clust < zscore2) / num_rand



mean (same_path_same_clust_tandem$cor^2,na.rm = T)


tand1 <- read.table ("results_all_tandem_non_tandem_duplicates.txt")

results_tandem <- tand1[tand1[,1] == tand1[,2] & (abs(tand1[,3] - tand1[,4]) < 500000),]
results_nontandem <- tand1[!(tand1[,1] == tand1[,2] & (abs(tand1[,3] - tand1[,4]) < 500000)),]

mean (results_tandem[,5]^2)
mean (results_nontandem[,5]^2)

##FIGURE S12
plot (density(same_path_same_clust_tandem$cor^2, from = 0, to = 1,n = 30),type = "l", col = "red",lwd = 2, xlab = expression (paste("Correlation in expression among genes (",rho^2,")")), main = "")
points(density(results_tandem[,5]^2, from = 0, to = 1,n = 30),type = "l", col = "purple", lty = 2,lwd = 2)
points(density(results_nontandem[,5]^2, from = 0, to = 1,n = 30),type = "l", col = "blue", lty = 3,lwd = 2)

legend ("topleft",c("BIA tandem duplicates","Non-BIA tandem duplicates","non-BIA non-tandem duplicates"),lty = c(1,2,3), col = c("red","purple","blue"),cex = 1, lwd = c (2,2,2))






