

##Written by Sam Yeaman
##Used to plot the figures comparing the Guo et al. assembly with the Hi-C scaffolding, included in the supp mat

options(stringsAsFactors=F)

setwd("~/Dropbox/desktop/for_sukyi/")
	
gff_new <- read.table ("~/Dropbox/desktop/for_sukyi/poppy_annotgene_to_hic_inversionfixed_filtered_singlepath.gff3",sep = "\t")
gff_guo <- read.table ("~/Dropbox/desktop/for_sukyi/poppy_annotgene_to_guo_filtered.gff3",sep = "\t")


gff_new2 <- gff_new[grep("mRNA", gff_new[,3]),]
int1 <- sapply(strsplit (gff_new2[,9],split = ";"),"[[",5) ##filter by ID
int2 <- sapply(strsplit (int1,split = "="),"[[",2)
gff_new3 <- gff_new2[which(as.numeric (int2) > 99),] 
int1 <- sapply(strsplit (gff_new3[,9],split = ";"),"[[",4) #filter by coverage
int2 <- sapply(strsplit (int1,split = "="),"[[",2)
gff_new4 <- gff_new3[which(as.numeric (int2) > 99),]
gff_new5 <- gff_new4[grep ("path1",gff_new4[,9]),]


int1 <- sapply(strsplit (gff_new5[,9],split = ";"),"[[",2)
gff_new5$gene <- sapply(strsplit (int1,split = "="),"[[",2)
gff_new5$path <- sapply(strsplit (gff_new5[,9],split = ";"),"[[",3)
		
	

gff_guo2 <- gff_guo[grep("mRNA", gff_guo[,3]),]
int1 <- sapply(strsplit (gff_guo2[,9],split = ";"),"[[",5) ##filter by ID
int2 <- sapply(strsplit (int1,split = "="),"[[",2)
gff_guo3 <- gff_guo2[which(as.numeric (int2) > 99),] 
int1 <- sapply(strsplit (gff_guo3[,9],split = ";"),"[[",4) #filter by coverage
int2 <- sapply(strsplit (int1,split = "="),"[[",2)
gff_guo4 <- gff_guo3[which(as.numeric (int2) > 99),]
gff_guo5 <- gff_guo4[grep ("path1",gff_guo4[,9]),]

	

int1 <- sapply(strsplit (gff_guo5[,9],split = ";"),"[[",2)
gff_guo5$gene <- sapply(strsplit (int1,split = "="),"[[",2)
gff_guo5$path <- sapply(strsplit (gff_guo5[,9],split = ";"),"[[",3)
	
merg_gff <- merge (gff_new5,gff_guo5,by.x = "path",by.y = "path")
merg_gff2 <- cbind (merg_gff[,1],merg_gff$V1.x,merg_gff$V4.x,merg_gff$V1.y,merg_gff$V4.y)
merg_gff3 <- merg_gff2[order(merg_gff2[,2],as.numeric (merg_gff2[,3])),]
merg_gff4 <- merg_gff3[grep ("NC",merg_gff3[,4]),]
ind1 <- paste (merg_gff4[,2],merg_gff4[,4], sep = "---")


tab1 <- sort (table(ind1),decreasing = T)

matches1 <- strsplit (names(tab1[1:11]), split = "---")
int11 <- strsplit (sapply (matches1,"[[",1),split = "__")
int12 <- strsplit (sapply (int11,"[[",1),split = "scaffold")

matches2 <- cbind (sapply (matches1,"[[",1),sapply (matches1,"[[",2),as.numeric (sapply(int12,"[[",2)))


matches2 <- matches2[order(as.numeric (matches2[,3])),]

all_mismatch1 <- NULL
all_mismatch2 <- NULL
all_mismatch3 <- NULL

pdf ("dot_plot_guo_hic_inversions.pdf")
for (ii in 1:nrow (matches2)){
	
	
	sub1 <- merg_gff3[merg_gff3[,2] == matches2[ii,1],] #get all cases corresponding to Hi-C chromsome ii
	
	sub2 <- merg_gff3[merg_gff3[,4] == matches2[ii,2],] #get all cases corresponding to Guo chromsome ii
	
	sub_both <- sub1[sub1[,1] %in% sub2[,1],]
	
	sub1b <- sub1[!(sub1[,1] %in% sub_both[,1]),] #genes present in HiC assembly but on a different chromosome in Guo
	sub2b <- sub2[!(sub2[,1] %in% sub_both[,1]),] #genes present in Guo but on a different chromosome HiC

	all_mismatch2 <- rbind (all_mismatch2,sub1b)
	all_mismatch3 <- rbind (all_mismatch3,sub2b)

	sub1c <- sub1b[grep ("NC",sub1b[,4]),]
	sub1w <- sub1b[grep ("NW",sub1b[,4]),]

	all_mismatch1 <- rbind (all_mismatch1,sub1c)


	the_main1 <- sapply(strsplit ( matches2[ii,1],split = "scaffold"),"[[",2)
	the_main2 <- sapply(strsplit ( the_main1,split = "__"),"[[",1)
	the_main3 <- paste ("cScaf",(as.numeric(the_main2)+1),sep = "")


plot (as.numeric (sub_both[,5]), as.numeric (sub_both[,3]), pch = 19, cex = 0.3, xlab = "Guo assembly (Mbp)", ylab = "Hi-C assembly (Mbp)", main = the_main3, xaxt = "n", yaxt = "n", xlim = c (0,max (as.numeric (sub2[,5]))), ylim = (c(0,max(as.numeric (sub1[,3])))))
	if (length (sub1c) > 5){
		points (array (0,nrow (sub1c)),as.numeric (sub1c[,3]), pch = 3, cex = 0.5, col = "blue") #MISMATCHES
	}
	if (length (sub1w) > 5){
		points (array (0,nrow (sub1w)),as.numeric (sub1w[,3]), pch = 3, cex = 0.5, col = "red") # UNPLACED IN GUO
	}
	if (length (sub2b) > 5){
		points (as.numeric (sub2b[,5]),array (0,nrow (sub2b)), pch = 3, cex = 0.5, col = "blue") #MISMATCHES
	}
	axis (side = 1,at = c (0,5e7,1e8,1.5e8,2e8,2.5e8,3e8),labels = c(0,50,100,150,200,250,300))
	axis (side = 2,at = c (0,5e7,1e8,1.5e8,2e8,2.5e8,3e8),labels = c(0,50,100,150,200,250,300))
	
}
dev.off()


write.table (all_mismatch1,"mismatching_genes_hic_vs_guo.txt",quote = F, col.names = F, row.names = F, sep = "\t")
write.table (all_mismatch2,"genes_not_placed_in_guo_placed_in_hic.txt",quote = F, col.names = F, row.names = F, sep = "\t")

