
##Written by Sam Yeaman
##Used for generating the plots of expression in particular pathways in Figure S11. Requires that the script "test_coexpression_in_clusters_guo109_permute_original.R" be run first to make the "res_cor" and other dataframes.


library (gplots)

par (mfcol = c (1,3))

nos1 <- res_cor[which(res_cor$path1 == "noscapine" & res_cor$path2 == "noscapine"),]


exp_nos <- exp_all[exp_all$pathway_new.y == "noscapine",]

gen1 <- unique (exp_nos$Gene_ID)


res1 <- array (NA, c(length (gen1),length(gen1)))
gen2 <- gen1

for (i in 1:length (gen1)){
for (j in 1:length (gen1)){
	if (i != j){
	gen2[i] <- exp_nos$Gene_ID[i]	
	sub1_check <- rbind (as.numeric (exp_nos[i,ind_cut1:ind_cut2]),as.numeric (exp_nos[j,ind_cut1:ind_cut2]))

	res1 [i,j] <- cor ((log10(sub1_check[1,]+1)),log10(sub1_check[2,]+1),method="spearman")		
	}
}
}

res2 <- res1^2
colnames(res2) <- gen2
rownames(res2) <- gen2


heatmap.2 (res2,trace = "none", dendrogram = "none",  key = T, Rowv = F, Colv = F,margins=c(14,8), col = colorRampPalette(c('red','blue')),key.title = "",density.info="none")


#thebaine
#thebaine
#thebaine
#thebaine
#thebaine
#thebaine


the1 <- res_cor[which(res_cor$path1 == "thebaine" & res_cor$path2 == "thebaine"),]


exp_the <- exp_all[exp_all$Chromosome == "thebaine",]

exp_the <- exp_the[order(exp_the$Chromosome,exp_the$Start),]

gen1 <- unique (exp_the$Gene_ID)


res1 <- array (NA, c(length (gen1),length(gen1)))
gen2 <- gen1

for (i in 1:length (gen1)){
for (j in 1:length (gen1)){
	if (i != j){
	gen2[i] <- exp_the$Gene_ID[i]	
	sub1_check <- rbind (as.numeric (exp_the[i,ind_cut1:ind_cut2]),as.numeric (exp_the[j,ind_cut1:ind_cut2]))

	res1 [i,j] <- cor ((log10(sub1_check[1,]+1)),log10(sub1_check[2,]+1),method="spearman")		
	}
}
}

res2 <- res1^2
colnames(res2) <- gen2
rownames(res2) <- gen2


heatmap.2 (res2,trace = "none", dendrogram = "none",  key = T, Rowv = F, Colv = F,margins=c(14,8), col = colorRampPalette(c('red','blue')),key.title = "",density.info="none")



###TEST cScaf3
###TEST cScaf3
###TEST cScaf3
###TEST cScaf3



exp_scaf3 <- exp_all[exp_all$scaffold_name == "PGA_scaffold2",]

exp_scaf3 <- exp_scaf3[exp_scaf3$Start > 280000000,]
exp_scaf3 <- exp_scaf3[order(exp_scaf3$Chromosome,exp_scaf3$Start),]

gen1 <- unique (exp_scaf3$Gene_ID)


res1 <- array (NA, c(length (gen1),length(gen1)))
gen2 <- gen1

for (i in 1:length (gen1)){
for (j in 1:length (gen1)){
	if (i != j){
	gen2[i] <- exp_scaf3$Gene_ID[i]	
	sub1_check <- rbind (as.numeric (exp_scaf3[i,ind_cut1:ind_cut2]),as.numeric (exp_scaf3[j,ind_cut1:ind_cut2]))

	res1 [i,j] <- cor ((log10(sub1_check[1,]+1)),log10(sub1_check[2,]+1),method="spearman")		
	}
}
}

res2 <- res1^2
colnames(res2) <- gen2
rownames(res2) <- gen2


heatmap.2 (res2,trace = "none", dendrogram = "none",  key = T, Rowv = F, Colv = F,margins=c(14,8), col = colorRampPalette(c('red','blue')),key.title = "",density.info="none",main = scaf_names[bb])

