
##Written by Sam Yeaman
##Used for generating the tables for enrichment of TE insertions and the stats comparing them to the whole genome, Table S10



results_all <- read.table ("~/Dropbox/desktop/for_sukyi/te_insertion_frequency_fine_rep10k_new_gff_109genes_500kb.txt")

res_filt_bonfer <- results_all[is.na(results_all[,5]) == F,] #bonferroni correct on the number of tests done for each cluster, excluding NA's, but keeping any other tests.

res_filt <- results_all[results_all[,6] >= 3 & is.na(results_all[,5]) == F,]

res_filt$clustername <- paste(res_filt[,1],res_filt[,2],sep = "__")

tests_per_cluster <- table (res_filt$clustername)

bonfer <- 0.05 / tests_per_cluster

bonfer2 <- cbind (names(bonfer),bonfer)
colnames (bonfer2) <- c("type","bonfer")

res_filt2 <- merge (res_filt,bonfer2, by.x = "clustername", by.y = "type", all.x = T)

res_filt3 <- res_filt2[as.numeric (res_filt2[,6]) < as.numeric (res_filt2$bonfer),]


res_filt3 <- res_filt3[order (res_filt3[,2],res_filt3[,3]),]
res_filt3 <- res_filt3[,-1]

colnames(res_filt3) <- c("te_name","scaffold","start","stop","pvalue","number_te","bonferroni")

write.table (res_filt3,"te_enrichment_per_cluster_bonferroni_NEW_GFF_109genes_500kb.txt", row.names = F, quote = F, sep = "\t")



gff <- as.matrix (read.table ("~/Dropbox/desktop/for_sukyi/PGA_assembly_fix_inversions_shortheaders.fasta.class.gff", sep = "\t"))


all_clust <- tapply (res_filt2$V6,res_filt2$V4,sum)

all_clust2 <- cbind (names(all_clust),all_clust)

wgte <- array (NA, nrow(all_clust2))

for (i in 1:length (wgte)){
	
	wgte[i] <- sum (gff[,13] == all_clust2[i,1])
}


test1 <- rbind(all_clust2[,2],wgte)
write.table (test1,"temp454.txt")
test1 <- read.table ("temp454.txt")

ch1 <- chisq.test(test1)

