##Written by Sam Yeaman
##used to do permutation testing on the clusters containing TEs to see if they are enriched relative to the rest of the genome
##Feeds into scripts for generating tables ("analyze_te_insertion_frequency.R"), Table S10

options(stringsAsFactors=F)
setwd("~/Dropbox/desktop/for_sukyi")



clusters <- read.table ("~/Dropbox/desktop/for_sukyi/poppy_clusters_500kb_5kwindow_new109.txt",T, sep = "\t")

clusters$chrom_mod <- sapply (strsplit(as.character (clusters$chrom), split = "__"),"[[",1)


gff <- as.matrix (read.table ("~/Dropbox/desktop/for_sukyi/PGA_assembly_fix_inversions_shortheaders.fasta.class.gff", sep = "\t"))
gff <- gff[grep("PGA",gff[,1]),]


trim1 <- strsplit (gff[,1],split = "_")



gff[,1] <- paste (sapply (trim1,"[[",1),"_",sapply (trim1,"[[",2),sep = "")

gff[,13] <- gsub ("DNA/MULE-MuDR","DNA/MuLE-MuDR",gff[,13])

int1 <- unique (gff[,1])
main_scaf <- int1[grep ("PGA_scaf",int1)]

main_scaf <- main_scaf[main_scaf %in% clusters$chrom_mod]


te_search1 <- table (gff[,13])
te_search2 <- te_search1[te_search1 > 100]

te_search <- names(te_search2)
te_search <- te_search[2:length (te_search)]
te_search <- te_search[!(te_search %in% c("Unknown","Satellite","Simple_repeat"))]

count <- 0

results_all <- array (NA,c((nrow(clusters)*length(te_search)),6))

numrep <- 10000


for (kk in 1:length (te_search)){

te_gff <- gff[gff[,13] == te_search [kk],]

te_gff_start <- as.numeric(te_gff[,4])
te_gff_end <- as.numeric (te_gff[,5])

for (ii in 1:nrow (clusters)){

	count <- count + 1

	gff_sub <- te_gff[which (te_gff[,1] == as.character (clusters[ii,]$chrom_mod)),]
	
	ind1 <- (as.numeric (gff_sub[,4]) > clusters[ii,]$start_5k) & (as.numeric (gff_sub[,5]) < clusters[ii,]$end_5k)
	clust1 <- gff_sub[which (ind1),]
	
	the_size <- clusters[ii,]$end_5k - clusters[ii,]$start_5k
	

	if (length(clust1) >= 26){ ##need at least 2 TE's to test:

	nulldist <- array (NA,numrep)
	num_clust <- length(clust1) / 13

	for (jj in 1:numrep){
		
		ran_scaf <- main_scaf[sample(1:length(main_scaf),1)]
		
		
		int1 <- te_gff[max(which (te_gff[,1] == ran_scaf)),5]		#get the largest annotation in the chromosome
		
		ran_int <- ceiling(runif (1,min=the_size,max= as.numeric (int1)))
		

		int2 <- which(te_gff_start > (ran_int - the_size) & (te_gff_end < ran_int) & te_gff[,1] == ran_scaf)
			
		nulldist[jj] <- length (int2)
	
	}
	
	results_all [count,5] <- sum (nulldist > num_clust) / length (nulldist)
	results_all [count,6] <- num_clust
		
	}
	results_all [count,1] <- as.character (clusters[ii,]$chrom_mod)
	results_all [count,2] <- as.character (clusters[ii,]$start)
	results_all [count,3] <- as.character (clusters[ii,]$end)
	results_all [count,4] <- as.character (te_search[kk])

}
}

write.table (results_all,"te_insertion_frequency_fine_rep10k_new_gff_109genes_500kb.txt",row.names = F, col.names = F, quote = F)

