##Written by Sam Yeaman
##used to do permutation testing on the clusters containing TEs to see if they have different ages relative to the rest of the genome.
##Table S11

options(stringsAsFactors=F)
setwd("~/Dropbox/desktop/for_sukyi")



clusters <- read.table ("~/Dropbox/desktop/for_sukyi/poppy_clusters_500kb_5kwindow_new109.txt",T, sep = "\t")

clusters$chrom_mod <- sapply (strsplit(as.character (clusters$chrom), split = "__"),"[[",1)

gff <- as.matrix (read.table ("~/Dropbox/desktop/for_sukyi/PGA_assembly_fix_inversions_shortheaders.fasta.Kweighted.tsv", sep = "\t",T))
gff <- gff[grep("PGA",gff[,2]),]


trim1 <- strsplit (gff[,2],split = "_")


gff[,2] <- paste (sapply (trim1,"[[",1),"_",sapply (trim1,"[[",2),sep = "")

gff[,7] <- gsub ("DNA/MULE-MuDR","DNA/MuLE-MuDR",gff[,5])

int1 <- unique (gff[,2])
main_scaf <- int1[grep ("PGA_scaf",int1)]

main_scaf <- main_scaf[main_scaf %in% clusters$chrom_mod]


count <- 0

results_all <- array (NA,c(nrow(clusters),6))

numrep <- 10000


 te_gff_start <- as.numeric(te_gff[,3])
 te_gff_end <- as.numeric (te_gff[,4])

te_gff <- gff

for (ii in 1:nrow (clusters)){

	count <- count + 1

	gff_sub <- te_gff[which (te_gff[,2] == as.character (clusters[ii,]$chrom_mod)),]
	
	ind1 <- (as.numeric (gff_sub[,3]) > clusters[ii,]$start_5k) & (as.numeric (gff_sub[,4]) < clusters[ii,]$end_5k)
	clust1 <- gff_sub[which (ind1),]
	
	the_size <- clusters[ii,]$end_5k - clusters[ii,]$start_5k
	
	
	test1 <- t.test (as.numeric (clust1[,6]),as.numeric (te_gff[,6]))
		
	results_all [count,5] <- test1$p.value
	results_all [count,6] <- mean (as.numeric (clust1[,6]))
		
	
	results_all [count,1] <- as.character (clusters[ii,]$chrom_mod)
	results_all [count,2] <- as.character (clusters[ii,]$start)
	results_all [count,3] <- as.character (clusters[ii,]$end)
	results_all [count,4] <- nrow (clust1)

}



write.table (results_all,"te_insertion_age_rep10k_new_gff_109genes_500kb.txt",row.names = F, col.names = F, quote = F)

