
##Written by Sam Yeaman
##Used for the "incremental" test of clustering distance used in Table S4 and S5



options(stringsAsFactors=F)
setwd("~/Dropbox/desktop/for_sukyi")
 

pathway <- read.table ("~/Dropbox/desktop/for_sukyi/pathway_genes_hic_inversion_clustered_TANDEM_FINE_fortest.txt", T, sep = "\t")


contigs <- unique (pathway$Chromosome)
lengths <- sapply(strsplit(contigs, split = "_"),"[[",8)

all_diffs <- NULL



ind1 <- grep ("clust",colnames(pathway))

nam1 <- sapply (strsplit (colnames (pathway)[ind1],split = "clust"), "[[",2)

the_clust <- colnames(pathway)[ind1]


uniq1 <- unique (pathway$Chromosome)
sep1 <- sapply (strsplit (as.character (uniq1),split = "_length_"),"[[",2)
gsize <- sum (as.numeric (sep1))

num_rep <- 10000

pathway$length <- sapply(strsplit(pathway$Chromosome, split = "_"),"[[",8)	

results_clust <- array (NA,c((length (the_clust) - 1),3))


for (i in 1:(length (the_clust) - 1)){

	in_clust <- pathway[pathway[,the_clust[i]] > 0,]
	out_clust <- pathway[pathway[,the_clust[i]] < 0,]

	the_num_clust <- array (NA, num_rep)

	for (yy in 1:num_rep){
		
		temp_clust <- out_clust
		
		for (bb in 1:nrow(out_clust)){
			
			temp_clust$Start [bb] <- floor(runif(1,0,as.numeric (temp_clust$length[bb])))
			
		}
		
		temp_all <- rbind (in_clust,temp_clust)
		temp_all <- temp_all[order(temp_all$Chromosome,temp_all$Start),]
		
		##RUN CLUSTERING ALGORITHM
		##RUN CLUSTERING ALGORITHM
		##RUN CLUSTERING ALGORITHM
		##RUN CLUSTERING ALGORITHM

		
		output <- temp_all
		new_pathway <- temp_all
	
		
		sub_contigs <- unique (new_pathway$Chromosome)

	
		all_clust <- NULL

		int1 <- as.numeric (nam1[i+1]) * 10^6 ##CLUSTERING DISTANCE

		cluster_count <- 1  #clustered genes get positive numbers
		non_count <- -1 ##non-clustered genes get negative numbers

		lastcluster <- FALSE

		##RUN CLUSTERING algorithm on new_pathway
		for (ii in 1:length (sub_contigs)){
		sub1 <- new_pathway[new_pathway$Chromosome == sub_contigs[ii],]	

		if (length (sub1) > 2){
		
			the_cluster <- array(NA,nrow (sub1))

			the_length <- as.numeric (sapply (strsplit (sub1[1,2],split = "_length_"),"[[",2))
	
	
			the_diffs <- abs(as.numeric (sub1[1:(nrow(sub1)-1),3]) - as.numeric (sub1[2:nrow(sub1),3]))
	
			smalls <- the_diffs < int1
	
		### Identify the clustered genes:
			ind1 <- which (smalls)

			clust1 <- array (NA,length (ind1))

			if (length (ind1) > 1){
			
				for (zz in 1:(length (ind1)-1)){
					if (ind1[zz] == (ind1[(zz+1)]-1)){
						clust1[zz] <- cluster_count
					} else {
						clust1[zz] <- cluster_count
						cluster_count <- cluster_count + 1
					}	
				}
				clust1[length(ind1)] <- cluster_count

				the_cluster [ind1] <- clust1
				the_cluster [ind1+1] <- clust1

				cluster_count <- cluster_count + 1
			} 
			if (length (ind1) == 1){ #if only one pair of genes is clustered
				the_cluster [ind1] <- cluster_count
				the_cluster [ind1+1] <- cluster_count
				cluster_count <- cluster_count + 1
			}
			
			
			#code any remaining NA's as non-clustered genes	
			ind2 <- which (is.na(the_cluster))
		
			if (length (ind2) > 0){  
				seq4 <- seq (non_count, (non_count - length (ind2) + 1), by = -1)
	
				the_cluster [ind2] <- seq4
	
				non_count <- min (the_cluster) - 1
			}
	
			all_clust <- c (all_clust,the_cluster)
			
		} else {
			all_clust <- c (all_clust,non_count)
		
			non_count <- non_count - 1
		}
		
		}
	
	
	inclust <- all_clust [all_clust > 0]
	tab1 <- table (inclust)

		
	the_num_clust [yy]	<- sum (all_clust > 0)
		

	}
	
	
	results_clust[i,1] <- as.numeric (nam1[i+1])
	results_clust[i,2] <- sum (pathway[,colnames(pathway) == the_clust[(i+1)]] > 0)
	results_clust[i,3] <- (sum (the_num_clust > results_clust[i,2])) / num_rep
#	results_clust[i,4] <- sum (the_num_clust > results_clust[i,2]) 

	
	
}


colnames(results_clust) <- c ("clustering_distance","number_of_genes_clustered","p-value")


#write.table (results_clust,"test_clustering_distance_incremental_FINE.txt",col.names = T, row.names = F, quote = F, sep = "\t")
write.table (results_clust,"test_clustering_distance_incremental_TANDEM_FINE.txt",col.names = T, row.names = F, quote = F, sep = "\t")






