

##Written by Sam Yeaman
##Used to generate the stats comparing the Guo et al. (2018) genome assembly with the assembly generated in the Li et al. poppy paper



setwd("~/Dropbox/desktop/for_sukyi/")
options (stringsAsFactors = F)	
	
gff_both <- read.table ("~/Dropbox/desktop/for_sukyi/109-entry_pathway_gene_FIXED.list",T,sep = "\t")

gff_both$New.name <- sapply (strsplit (gff_both[,1],split = ".", fixed = T),"[[",1)

guo_mapped <- gff_both[grep ("NC",gff_both$Guo_contig),]
guo_unmapped <- gff_both[grep ("NW",gff_both$Guo_contig),]

bia <- read.table ("~/Dropbox/desktop/for_sukyi/pathwaygenes_good58_names.txt")


##how many core BIA genes resolved in the guo assembly:
sum (bia[,1] %in% guo_mapped$New.name)


##how many paralogs are mapped in the guo assembly:
nrow (guo_mapped) - sum (bia[,1] %in% guo_mapped$New.name)



##which ones are missing?
bia[!(bia[,1] %in% guo_mapped$New.name),]

##how many BIA genes resolved in the hic-inversions assembly:
sum (bia[,1] %in% gff_both$New.name)

