##Written by Sam Yeaman
##Used to plot Figure 4, showing the heatmap for genes expression in rows and alkaloid concentrations in columns.




options(stringsAsFactors=F)
setwd("~/Dropbox/desktop/for_sukyi")


library (gplots)

exp1 <- read.table ("~/Dropbox/desktop/for_sukyi/gene_tpm_all_samples_filt.path.clust.tsv",T)


pathways <- read.table ("~/Dropbox/desktop/for_sukyi/109-entry_pathway_gene_FIXED.list",T,sep = "\t")

orb1 <- read.table ("~/Dropbox/desktop/for_sukyi/Consolidated_OrbitrapAlkaloid_Data_March25-2019_KNOWN_ALKALOIDS_pooja_hmap_sam.txt",T,sep = "\t")

exp2 <- cbind (as.character(exp1$Gene_ID),exp1$Pslatex,exp1$PS.leaf,exp1$PS.MC,exp1$PS.root,exp1$PS.S1,exp1$PS.S2,exp1$PS.S3,exp1$PS.S4,exp1$PS.S5,exp1$PS.S6,exp1$PS.S7,exp1$PS.stem,exp1$PS.YC,as.character(exp1$pathway_new),as.character (exp1$position))


orb2 <- cbind (as.character(orb1$new.name),orb1$latex_mean,orb1$leaf_mean,orb1$MC_mean,orb1$root_mean,orb1$s1_mean,orb1$s2_mean,orb1$s3_mean,orb1$s4_mean,orb1$s5_mean,orb1$s6_mean,orb1$s7_mean,orb1$stem_mean,orb1$YC_mean)


write.table (exp2,"trash55.txt")
exp2 <- read.table ("trash55.txt")
 

write.table (orb2,"trash55.txt")
orb2 <- read.table ("trash55.txt")
 


filt1 <- rowSums (exp2[,2:14])

exp2 <- exp2[filt1 > 100,]


exp2 <- exp2[order(exp2[,15]),] #reorder1

retind <- which (exp2[,15] == "reticuline" | exp2[,15] == "reticuline_derivatives")
dopind <- which (exp2[,15] == "dopamine_4HPAA")
sangind <- which (exp2[,15] == "sanguinarine")
papind <- which (exp2[,15] == "papaverine")
morphind <- which (exp2[,15] == "morphine")
theind <- which (exp2[,15] == "thebaine")
nosind <- which (exp2[,15] == "noscapine")
unkind <- which (exp2[,15] == "unknown")
papsangind <- which (exp2[,15] == "papaverine_sanguinarine")

exp2 <- exp2 [c(dopind,retind,theind,morphind,unkind,nosind,papind,papsangind,sangind),]

res1 <- array (NA, c(nrow(exp2),nrow(orb2)))

for (i in 1:nrow(exp2)){
for (j in 1:nrow(orb2)){
	
	
	res1[i,j] <- cor (log10(as.numeric (exp2[i,(2:14)])+1),log10(as.numeric (orb2[j,(2:ncol(orb2))]+1)))
}	
}

nam1 <- sapply (strsplit (orb2[,1],split = "_"),"[[",3)
nam2 <- gsub (".pseudo","",exp2[,1],fixed = T)


colnames (res1) <- nam1
rownames (res1) <- nam2

exp1$Gene_ID_trimmed <- gsub (".pseudo","",exp1$Gene_ID,fixed = T)

col1 <- rownames(res1)
col2 <- col1

for (i in 1:length (col2)){
	col2[i] <- exp1[exp1$Gene_ID_trimmed == col1[i],]$pathway_new
}

col_plot <- col2

col_plot[col_plot == "morphine"] <- 1
col_plot[col_plot == "thebaine"] <- 2
col_plot[col_plot == "noscapine"] <- 3
col_plot[col_plot == "reticuline"] <- 4
col_plot[col_plot == "dopamine_4HPAA"] <- 5
col_plot[col_plot == "sanguinarine"] <- 6
col_plot[col_plot == "unknown"] <- 7
col_plot[col_plot == "papaverine"] <- 8
col_plot[col_plot == "papaverine_derivatives"] <- 8
col_plot[col_plot == "papaverine_sanguinarine"] <- 8
col_plot[col_plot == "protopine_derivatives"] <- 9
col_plot[col_plot == "reticuline_derivatives"] <- 4
col_plot <- as.numeric (col_plot)
the_cols <- c("cyan","purple","black",rgb(0.5,0,0),"orange","red",rgb(0,0.5,1),rgb(0.75,0.75,0.25),rgb(0,0.5,0.5),"pink")


#heatmap.2 (res1,trace = "none", dendrogram = "none",  key = T, Rowv = T, Colv = F,margins=c(14,8), col = colorRampPalette(c('dark red','white','dark blue')),colRow = the_cols[col_plot])

#heatmap.2 (res1,trace = "none", dendrogram = "none",  key = T, Rowv = F, Colv = F,margins=c(14,8), col = colorRampPalette(c('dark red','white','dark blue')),colRow = the_cols[col_plot])
heatmap.2 (res1,trace = "none", dendrogram = "none",  key = T, Rowv = F, Colv = T,margins=c(14,8), col = colorRampPalette(c('dark red','white','dark blue')),colRow = the_cols[col_plot],key.title = "",density.info="none")
par (las = 1)
#mtext("path1",col = "red",side = 4, padj = 48.3, adj = 1.45,cex = 0.6)

#heatmap.2 (res1,trace = "none", dendrogram = "none",  key = T, Rowv = F, Colv = T, labRow = gname, labCol = varnames,sepcolor = "black", col = cols1,colsep = 1:ncol(cnv),rowsep = 1:nrow(cnv), sepwidth = c (0.005,0.005),adjCol = c(0.8,0.5))

