
##Written by Sam Yeaman
##Used for conducting the "global" test of whether genes are clustered, based on a few different input files (either including tandem duplicates or not, and using a range of possible clustering distances). Used in Table S4 and S5



options(stringsAsFactors=F)
setwd("~/Dropbox/desktop/for_sukyi")
 
input <- read.table ("pathway_genes_hic_inversion_clustered.txt",T,sep = "\t")  #include tandem duplications

input <- read.table ("pathway_genes_hic_inversion_clustered_FINE.txt",T,sep = "\t")  

input <- read.table ("pathway_genes_hic_inversion_clustered_TANDEM_FINE.txt",T,sep = "\t") #exclude tandem duplications



the_cut_names <- paste ("clust",c(0.1,0.2,0.5,1,5,10,20,50,100),sep = "") ##Set this for the table 
all_cuts <- c(0.1,0.2,0.5,1,5,10,20,50,100)


all_cuts <- c(0.001,0.0025,0.005,0.0075,0.01,0.02,0.03,0.04,0.05,0.075,0.1,0.2,0.5,1,5,10,20,50,100)  ##set this for the figure, comment for the table
the_cut_names <- paste ("clust",all_cuts,sep = "")



numrep <- 10000

contigs <- unique (input$Chromosome)


the_cuts <- all_cuts[1]
the_cuts <- the_cuts * 10^6





numrep <- 10000
results_all <- array (NA, c(length(all_cuts),3))

path_newchrom <- input$Chromosome
int2 <- sapply(strsplit (path_newchrom,split = "length_"),"[[",2)

contigs <- unique (input$Chromosome)

for (gg in 1:length(all_cuts)){ 

	this_cut <- all_cuts[gg] * 10^6
	

	results <- array (NA, c (numrep,4))

for (i in 1:numrep){

	set.seed(i)	
	path_newloc <- ceiling(runif (length (int2),min = 0, max = as.numeric (int2) - 1))
	
	new_pathway <- cbind(path_newchrom,path_newloc)
	
	new_pathway <- new_pathway[order(new_pathway[,1],as.numeric (new_pathway[,2])),]

	output <- new_pathway


	all_clust <- NULL

	int1 <- this_cut

	cluster_count <- 1  #clustered genes get positive numbers
	non_count <- -1 ##non-clustered genes get negative numbers

	lastcluster <- FALSE

	##RUN CLUSTERING algorithm on new_pathway
	for (ii in 1:length (contigs)){
		sub1 <- new_pathway[new_pathway[,1] == contigs[ii],]	

		if (length (sub1) > 2){
		
			the_cluster <- array(NA,nrow (sub1))

			the_length <- as.numeric (sapply (strsplit (sub1[1,1],split = "_length_"),"[[",2))
	
	
			the_diffs <- abs(as.numeric (sub1[1:(nrow(sub1)-1),2]) - as.numeric (sub1[2:nrow(sub1),2]))
	
			smalls <- the_diffs < int1
	
		### Identify the clustered genes:
			ind1 <- which (smalls)

			clust1 <- array (NA,length (ind1))

			if (length (ind1) > 1){
			
				for (zz in 1:(length (ind1)-1)){
					if (ind1[zz] == (ind1[(zz+1)]-1)){
						clust1[zz] <- cluster_count
					} else {
						clust1[zz] <- cluster_count
						cluster_count <- cluster_count + 1
					}	
				}
				clust1[length(ind1)] <- cluster_count

				the_cluster [ind1] <- clust1
				the_cluster [ind1+1] <- clust1

				cluster_count <- cluster_count + 1
			} 
			if (length (ind1) == 1){ #if only one pair of genes is clustered
				the_cluster [ind1] <- cluster_count
				the_cluster [ind1+1] <- cluster_count
				cluster_count <- cluster_count + 1
			}
			
			
			#code any remaining NA's as non-clustered genes	
			ind2 <- which (is.na(the_cluster))
		
			if (length (ind2) > 0){  
				seq4 <- seq (non_count, (non_count - length (ind2) + 1), by = -1)
	
				the_cluster [ind2] <- seq4
	
				non_count <- min (the_cluster) - 1
			}
	
			all_clust <- c (all_clust,the_cluster)
			
		} else {
			all_clust <- c (all_clust,non_count)
		
			non_count <- non_count - 1
		}
		
	}
	
	
	inclust <- all_clust [all_clust > 0]
	tab1 <- table (inclust)
	
	
	results[i,1] <- length (inclust)
	results[i,2] <- length (tab1)
	if (length (tab1) > 0){
		results[i,3] <- max (tab1)
		results[i,4] <- mean (tab1)
	}

		
	} #end rep loop
	 
	 to_cluster <- which (colnames (input) == the_cut_names[gg])

	 new_int <- input[input[,to_cluster] > 0,]
	 
	 results_all[gg,1] <- all_cuts[gg]
	 results_all[gg,2] <- nrow (new_int) ##how many are clustered
	 results_all[gg,3] <- sum (results[,1] >= nrow(new_int)) #empirical p-value
	 

}











